/*
Nome: 9809_CDPTRGS_LOG_CDP_ESPEPROD.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato

 Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              ESPEPROD, para verifio de erros */
IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_CDP_ESPEPROD' AND
                TYPE   = 'TR'               AND
                U.UID  = O.UID              AND
                U.NAME = USER)

DROP TRIGGER LOG_CDP_ESPEPROD
GO


CREATE TRIGGER LOG_CDP_ESPEPROD
ON ESPEPROD
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(2000);
   DECLARE @V_ITPESQ       VARCHAR(80);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDCLIEATIV   VARCHAR(1);
   DECLARE @V_NRINCREST    VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_TRIGGER       VARCHAR(1);

   DECLARE @V_CDFILIAL_OLD      VARCHAR(4);
   DECLARE @V_CDPRODUTO_OLD     VARCHAR(10);
   DECLARE @V_CDESPEPROD_OLD    VARCHAR(10);
   DECLARE @V_NMESPEPROD_OLD    VARCHAR(50);
   DECLARE @V_DTVALESPEPRO_OLD  DATETIME;
   DECLARE @V_DTINCESPEPRO_OLD  DATETIME;
   DECLARE @V_QTPADESPEPRO_OLD  double precision;
   DECLARE @V_CDOPERADOR_OLD    VARCHAR(12);
   DECLARE @V_CDCIA_OLD         VARCHAR(4);
   DECLARE @V_CDMANCIA_OLD      VARCHAR(4);
   DECLARE @V_IDTPMANUAL_OLD    VARCHAR(1);
   DECLARE @V_IDCOMPPADRAO_OLD  VARCHAR(1);
   DECLARE @V_DTAPRESENTA_OLD   DATETIME;
   DECLARE @V_NMFOTOESP_OLD     VARCHAR(30);
   DECLARE @V_DTEFETIVA_OLD     DATETIME;
   DECLARE @V_DTREVISAO_OLD     DATETIME;
   DECLARE @V_CDPRODUTOPRI_OLD  VARCHAR(10);
   DECLARE @V_DTULTATUESPR_OLD  DATETIME;
   DECLARE @V_DSSUBGRUPO_OLD    VARCHAR(50);

   DECLARE @V_CDFILIAL_NEW      VARCHAR(4);
   DECLARE @V_CDPRODUTO_NEW     VARCHAR(10);
   DECLARE @V_CDESPEPROD_NEW    VARCHAR(10);
   DECLARE @V_NMESPEPROD_NEW    VARCHAR(50);
   DECLARE @V_DTVALESPEPRO_NEW  DATETIME;
   DECLARE @V_DTINCESPEPRO_NEW  DATETIME;
   DECLARE @V_QTPADESPEPRO_NEW  double precision;
   DECLARE @V_CDOPERADOR_NEW    VARCHAR(12);
   DECLARE @V_CDCIA_NEW         VARCHAR(4);
   DECLARE @V_CDMANCIA_NEW      VARCHAR(4);
   DECLARE @V_IDTPMANUAL_NEW    VARCHAR(1);
   DECLARE @V_IDCOMPPADRAO_NEW  VARCHAR(1);
   DECLARE @V_DTAPRESENTA_NEW   DATETIME;
   DECLARE @V_NMFOTOESP_NEW     VARCHAR(30);
   DECLARE @V_DTEFETIVA_NEW     DATETIME;
   DECLARE @V_DTREVISAO_NEW     DATETIME;
   DECLARE @V_CDPRODUTOPRI_NEW  VARCHAR(10);
   DECLARE @V_DTULTATUESPR_NEW  DATETIME;
   DECLARE @V_DSSUBGRUPO_NEW    VARCHAR(50);


/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDCLIEATIV = '';
   SET @V_NRINCREST  = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,

        CDFILIAL,
        CDPRODUTO,
	CDESPEPROD,
	NMESPEPROD,
	DTVALESPEPRO,
	DTINCESPEPRO,
        QTPADESPEPRO,
	CDOPERADOR,
	CDCIA,
	CDMANCIA,
	IDTPMANUAL,
	IDCOMPPADRAO,
	DTAPRESENTA,
	NMFOTOESP,
	DTEFETIVA,
	DTREVISAO,
	CDPRODUTOPRI,
	DTULTATUESPR,
	DSSUBGRUPO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,
        DELETED.CDFILIAL,
        DELETED.CDPRODUTO,
	DELETED.CDESPEPROD,
	DELETED.NMESPEPROD,
	DELETED.DTVALESPEPRO,
	DELETED.DTINCESPEPRO,
        DELETED.QTPADESPEPRO,
	DELETED.CDOPERADOR,
	DELETED.CDCIA,
	DELETED.CDMANCIA,
	DELETED.IDTPMANUAL,
	DELETED.IDCOMPPADRAO,
	DELETED.DTAPRESENTA,
	DELETED.NMFOTOESP,
	DELETED.DTEFETIVA,
	DELETED.DTREVISAO,
	DELETED.CDPRODUTOPRI,
	DELETED.DTULTATUESPR,
	DELETED.DSSUBGRUPO,
        INSERTED.CDFILIAL,
        INSERTED.CDPRODUTO,
	INSERTED.CDESPEPROD,
	INSERTED.NMESPEPROD,
	INSERTED.DTVALESPEPRO,
	INSERTED.DTINCESPEPRO,
        INSERTED.QTPADESPEPRO,
	INSERTED.CDOPERADOR,
	INSERTED.CDCIA,
	INSERTED.CDMANCIA,
	INSERTED.IDTPMANUAL,
	INSERTED.IDCOMPPADRAO,
	INSERTED.DTAPRESENTA,
	INSERTED.NMFOTOESP,
	INSERTED.DTEFETIVA,
	INSERTED.DTREVISAO,
	INSERTED.CDPRODUTOPRI,
	INSERTED.DTULTATUESPR,
	INSERTED.DSSUBGRUPO

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDPRODUTO  = DELETED.CDPRODUTO

      UNION ALL

      SELECT
        'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
        CDFILIAL,
        CDPRODUTO,
	CDESPEPROD,
	NMESPEPROD,
	DTVALESPEPRO,
	DTINCESPEPRO,
        QTPADESPEPRO,
	CDOPERADOR,
	CDCIA,
	CDMANCIA,
	IDTPMANUAL,
	IDCOMPPADRAO,
	DTAPRESENTA,
	NMFOTOESP,
	DTEFETIVA,
	DTREVISAO,
	CDPRODUTOPRI,
	DTULTATUESPR,
	DSSUBGRUPO

     FROM
        INSERTED
     WHERE
        0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,
                                
			  	 @V_CDFILIAL_OLD,
    				 @V_CDPRODUTO_OLD,
    				 @V_CDESPEPROD_OLD,
    				 @V_NMESPEPROD_OLD,
    				 @V_DTVALESPEPRO_OLD,
    				 @V_DTINCESPEPRO_OLD,
    				 @V_QTPADESPEPRO_OLD,
    				 @V_CDOPERADOR_OLD,
    				 @V_CDCIA_OLD,
    				 @V_CDMANCIA_OLD,
    				 @V_IDTPMANUAL_OLD,
    				 @V_IDCOMPPADRAO_OLD,
    				 @V_DTAPRESENTA_OLD,
    			         @V_NMFOTOESP_OLD,
    	 			 @V_DTEFETIVA_OLD,
    				 @V_DTREVISAO_OLD,	
    				 @V_CDPRODUTOPRI_OLD,
    			 	 @V_DTULTATUESPR_OLD,
    				 @V_DSSUBGRUPO_OLD,

				 @V_CDFILIAL_NEW,   
    				 @V_CDPRODUTO_NEW,  
			         @V_CDESPEPROD_NEW, 
    				 @V_NMESPEPROD_NEW, 
    				 @V_DTVALESPEPRO_NEW,
    				 @V_DTINCESPEPRO_NEW,
    				 @V_QTPADESPEPRO_NEW,
    				 @V_CDOPERADOR_NEW,
    				 @V_CDCIA_NEW,
    				 @V_CDMANCIA_NEW, 
    				 @V_IDTPMANUAL_NEW, 
    				 @V_IDCOMPPADRAO_NEW,
    				 @V_DTAPRESENTA_NEW,
				 @V_NMFOTOESP_NEW,
    				 @V_DTEFETIVA_NEW,
    				 @V_DTREVISAO_NEW,
    				 @V_CDPRODUTOPRI_NEW,
    				 @V_DTULTATUESPR_NEW,
   		 		 @V_DSSUBGRUPO_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN

    IF @V_ID_TRIGGER = 'I' BEGIN

           IF @V_CDFILIAL_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_NEW,'') + ' ' ;
           END;

           IF @V_CDPRODUTO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_NEW,'')    + ' ';
           END;

           IF @V_CDESPEPROD_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdEspecificProd= ' + ISNULL(@V_CDESPEPROD_NEW,'')   + ' ';
           END;

           IF @V_NMESPEPROD_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NmEspecificProd= ' + ISNULL(@V_NMESPEPROD_NEW,'')   + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTVALESPEPRO_NEW, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtValnicEspecProd= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTVALESPEPRO_NEW, 103),'')) + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTINCESPEPRO_NEW, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtIncluEspecProd= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTINCESPEPRO_NEW, 103),'')) + ' ';
           END;

           IF @V_QTPADESPEPRO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtPadraoEspecProd= ' + RTRIM(CONVERT(CHAR, @V_QTPADESPEPRO_NEW)) + ' ';
           END;

           IF @V_CDOPERADOR_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdOperador= ' + ISNULL(@V_CDOPERADOR_NEW,'') + ' ';
           END;

           IF @V_CDCIA_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdCompanhia= ' + @V_CDCIA_NEW + ' ';
           END;

           IF @V_CDMANCIA_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdManualCompanhia= ' + @V_CDMANCIA_NEW + ' ';
           END;

           IF @V_IDTPMANUAL_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoManual= ' + @V_IDTPMANUAL_NEW + ' ';
           END;

           IF @V_IDCOMPPADRAO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdComposicaoReceita= ' + @V_IDCOMPPADRAO_NEW + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTAPRESENTA_NEW, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtApresentacao= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTAPRESENTA_NEW, 103),'')) + ' ';
           END;

           IF @V_NMFOTOESP_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NomeFoto= ' + @V_NMFOTOESP_NEW + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTEFETIVA_NEW, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtEfetivacaoSub= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTEFETIVA_NEW, 103),'')) + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTREVISAO_NEW, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtRevisao= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTREVISAO_NEW, 103),'')) + ' ';
           END;

           IF @V_CDPRODUTOPRI_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProdutoPri= ' + @V_CDPRODUTOPRI_NEW + ' ';
           END;

           IF @V_DSSUBGRUPO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DescricaoSub-Grupo= ' + @V_DSSUBGRUPO_NEW + ' ';
           END;

        SET @V_ITPESQ = @V_CDPRODUTO_NEW + @V_CDESPEPROD_NEW;

        SET @V_IDTIPOOPER = '1';
     END
     ELSE BEGIN
        IF @V_ID_TRIGGER = 'U' BEGIN

           IF (@V_CDFILIAL_OLD <> @V_CDFILIAL_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_NEW,'') + ' ' ;
           END;

           IF (@V_CDPRODUTO_OLD <> @V_CDPRODUTO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_NEW,'')    + ' ';
           END;

           IF (@V_CDESPEPROD_OLD <> @V_CDESPEPROD_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdEspecificProd= ' + ISNULL(@V_CDESPEPROD_NEW,'')   + ' ';
           END;

           IF (@V_NMESPEPROD_OLD <> @V_NMESPEPROD_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'NmEspecificProd= ' + ISNULL(@V_NMESPEPROD_NEW,'')   + ' ';
           END;

           IF (ISNULL(CONVERT(CHAR, @V_DTVALESPEPRO_OLD, 103),'W') <> ISNULL(CONVERT(CHAR, @V_DTVALESPEPRO_NEW, 103),'W')) BEGIN
              SET @V_DESC = @V_DESC + 'DtValnicEspecProd= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTVALESPEPRO_NEW, 103),'')) + ' ';
           END;

           IF (ISNULL(CONVERT(CHAR, @V_DTINCESPEPRO_OLD, 103),'W') <> ISNULL(CONVERT(CHAR, @V_DTINCESPEPRO_NEW, 103),'W')) BEGIN
              SET @V_DESC = @V_DESC + 'DtIncluEspecProd= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTINCESPEPRO_NEW, 103),'')) + ' ';
           END;

           IF (@V_QTPADESPEPRO_OLD <> @V_QTPADESPEPRO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'QtPadraoEspecProd= ' + RTRIM(CONVERT(CHAR, @V_QTPADESPEPRO_NEW)) + ' ';
           END;

           IF (@V_CDOPERADOR_OLD <> @V_CDOPERADOR_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdOperador= ' + ISNULL(@V_CDOPERADOR_NEW,'') + ' ';
           END;

           IF (@V_CDCIA_OLD <> @V_CDCIA_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdCompanhia= ' + @V_CDCIA_NEW + ' ';
           END;

           IF (@V_CDMANCIA_OLD <> @V_CDMANCIA_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdManualCompanhia= ' + @V_CDMANCIA_NEW + ' ';
           END;

           IF (@V_IDTPMANUAL_OLD <> @V_IDTPMANUAL_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoManual= ' + @V_IDTPMANUAL_NEW + ' ';
           END;

           IF (@V_IDCOMPPADRAO_OLD <> @V_IDCOMPPADRAO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdComposicaoReceita= ' + @V_IDCOMPPADRAO_NEW + ' ';
           END;

           IF (ISNULL(CONVERT(CHAR, @V_DTAPRESENTA_OLD, 103),'W') <> ISNULL(CONVERT(CHAR, @V_DTAPRESENTA_NEW, 103),'W')) BEGIN
              SET @V_DESC = @V_DESC + 'DtApresentacao= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTAPRESENTA_NEW, 103),'')) + ' ';
           END;

           IF (@V_NMFOTOESP_OLD <> @V_NMFOTOESP_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'NomeFoto= ' + @V_NMFOTOESP_NEW + ' ';
           END;

           IF (ISNULL(CONVERT(CHAR, @V_DTEFETIVA_OLD, 103),'W') <> ISNULL(CONVERT(CHAR, @V_DTEFETIVA_NEW, 103),'W')) BEGIN
              SET @V_DESC = @V_DESC + 'DtEfetivacaoSub= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTEFETIVA_NEW, 103),'')) + ' ';
           END;

           IF (ISNULL(CONVERT(CHAR, @V_DTREVISAO_OLD, 103),'W') <> ISNULL(CONVERT(CHAR, @V_DTREVISAO_NEW, 103),'W')) BEGIN
              SET @V_DESC = @V_DESC + 'DtRevisao= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTREVISAO_NEW, 103),'')) + ' ';
           END;

           IF (@V_CDPRODUTOPRI_OLD <> @V_CDPRODUTOPRI_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdProdutoPri= ' + @V_CDPRODUTOPRI_NEW + ' ';
           END;

           IF (@V_DSSUBGRUPO_OLD <> @V_DSSUBGRUPO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'DescricaoSub-Grupo= ' + @V_DSSUBGRUPO_NEW + ' ';
           END;

           SET @V_ITPESQ = @V_CDPRODUTO_NEW + @V_CDESPEPROD_NEW;

           SET @V_IDTIPOOPER = '2';

        END;

        IF @V_ID_TRIGGER = 'D'  BEGIN

           IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_OLD,'') + ' ' ;
           END;

           IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_OLD,'')    + ' ';
           END;

           IF @V_CDESPEPROD_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdEspecificProd= ' + ISNULL(@V_CDESPEPROD_OLD,'')   + ' ';
           END;

           IF @V_NMESPEPROD_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NmEspecificProd= ' + ISNULL(@V_NMESPEPROD_OLD,'')   + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTVALESPEPRO_OLD, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtValnicEspecProd= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTVALESPEPRO_OLD, 103),'')) + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTINCESPEPRO_OLD, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtIncluEspecProd= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTINCESPEPRO_OLD, 103),'')) + ' ';
           END;

           IF @V_QTPADESPEPRO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtPadraoEspecProd= ' + RTRIM(CONVERT(CHAR, @V_QTPADESPEPRO_OLD)) + ' ';
           END;

           IF @V_CDOPERADOR_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdOperador= ' + ISNULL(@V_CDOPERADOR_OLD,'') + ' ';
           END;

           IF @V_CDCIA_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdCompanhia= ' + @V_CDCIA_OLD + ' ';
           END;

           IF @V_CDMANCIA_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdManualCompanhia= ' + @V_CDMANCIA_OLD + ' ';
           END;

           IF @V_IDTPMANUAL_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoManual= ' + @V_IDTPMANUAL_OLD + ' ';
           END;

           IF @V_IDCOMPPADRAO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdComposicaoReceita= ' + @V_IDCOMPPADRAO_OLD + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTAPRESENTA_OLD, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtApresentacao= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTAPRESENTA_OLD, 103),'')) + ' ';
           END;

           IF @V_NMFOTOESP_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NomeFoto= ' + @V_NMFOTOESP_OLD + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTEFETIVA_OLD, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtEfetivacaoSub= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTEFETIVA_OLD, 103),'')) + ' ';
           END;

           IF ISNULL(CONVERT(CHAR, @V_DTREVISAO_OLD, 103),NULL) IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DtRevisao= ' + RTRIM(ISNULL(CONVERT(CHAR, @V_DTREVISAO_OLD, 103),'')) + ' ';
           END;

           IF @V_CDPRODUTOPRI_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProdutoPri= ' + @V_CDPRODUTOPRI_OLD + ' ';
           END;

           IF @V_DSSUBGRUPO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'DescricaoSub-Grupo= ' + @V_DSSUBGRUPO_OLD + ' ';
           END;

        SET @V_ITPESQ = @V_CDPRODUTO_OLD + @V_CDESPEPROD_OLD;

           SET @V_IDTIPOOPER = '3';
        END;
     END;

     IF NOT (@V_DESC IS NULL) BEGIN

        INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                               IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                               DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                               DSMETUSUOPER, CDORESPOPER)
                    VALUES   ('ESPEPROD', GETDATE() ,    ISNULL(@V_NMOPERADOR,' '),
                               @V_IDTIPOOPER,   @V_DESC, @V_ITPESQ,
                               @V_DSSERVERRDM, @V_DSREMOTEADDR,  @V_DSREMOTEHOST,
                               @V_DSSERVMETHOD,   @V_DSREMOTEOPER);
     END;

   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

			  	 @V_CDFILIAL_OLD,
    				 @V_CDPRODUTO_OLD,
    				 @V_CDESPEPROD_OLD,
    				 @V_NMESPEPROD_OLD,
    				 @V_DTVALESPEPRO_OLD,
    				 @V_DTINCESPEPRO_OLD,
    				 @V_QTPADESPEPRO_OLD,
    				 @V_CDOPERADOR_OLD,
    				 @V_CDCIA_OLD,
    				 @V_CDMANCIA_OLD,
    				 @V_IDTPMANUAL_OLD,
    				 @V_IDCOMPPADRAO_OLD,
    				 @V_DTAPRESENTA_OLD,
    			         @V_NMFOTOESP_OLD,
    	 			 @V_DTEFETIVA_OLD,
    				 @V_DTREVISAO_OLD,	
    				 @V_CDPRODUTOPRI_OLD,
    			 	 @V_DTULTATUESPR_OLD,
    				 @V_DSSUBGRUPO_OLD,

				 @V_CDFILIAL_NEW,   
    				 @V_CDPRODUTO_NEW,  
			         @V_CDESPEPROD_NEW, 
    				 @V_NMESPEPROD_NEW, 
    				 @V_DTVALESPEPRO_NEW,
    				 @V_DTINCESPEPRO_NEW,
    				 @V_QTPADESPEPRO_NEW,
    				 @V_CDOPERADOR_NEW,
    				 @V_CDCIA_NEW,
    				 @V_CDMANCIA_NEW, 
    				 @V_IDTPMANUAL_NEW, 
    				 @V_IDCOMPPADRAO_NEW,
    				 @V_DTAPRESENTA_NEW,
				 @V_NMFOTOESP_NEW,
    				 @V_DTEFETIVA_NEW,
    				 @V_DTREVISAO_NEW,
    				 @V_CDPRODUTOPRI_NEW,
    				 @V_DTULTATUESPR_NEW,
   		 		 @V_DSSUBGRUPO_NEW;

   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CDP_ESPEPROD','5.07.000';
GO
